import java.io.*;
import java.net.*;
import java.text.SimpleDateFormat;
import java.util.*;

public class ConnectionHandler implements Runnable
{
	// TODO: Vector:گ޾, ײȰެ  ޯĻ
	static Vector<ConnectionHandler> clmgr = new Vector<ConnectionHandler>();
	
	BufferedReader in  = null;
	BufferedWriter out = null;
	Socket socket;
	String line;
	String name;
	
	// ݽ׸
	public ConnectionHandler(Socket socket) {
		this.socket = socket;
	}

	public void run() {
		try {
			in = new BufferedReader(new InputStreamReader(
		    		socket.getInputStream(), TCPServer.ENCODING), TCPServer.BUFFER_SIZE);
		    out = new BufferedWriter(new OutputStreamWriter(
		    		socket.getOutputStream(), TCPServer.ENCODING), TCPServer.BUFFER_SIZE);

		    while (true)
            {
		    	try {
	                line = in.readLine();
	                if(line == null) {
	                	break;
	                } else {
	                	// TODO: ئ ܹ ۼޯ ֳ
	                	
	                	// Tvł͊ȗ̂ߐ擪4
	                	// U蕪̃L[ƂĎgpĂ݂
	                	
	                	String code = line.substring(0, 4);
	                	String body = line.substring(4);
	
	                	switch (Integer.parseInt(code)) {
	                		case 0: //Oݒ
	                			setName(body);
	                			break;
	                		case 1: // bZ[W̑M
	                        	sendAll(name, body);
	                			break;
	                	}
	                }
				} catch (StringIndexOutOfBoundsException e) {
					writeLog(" zÕf[^^M data:" + line + ",", e);
				} catch (NumberFormatException e) {
					writeLog(" zÕf[^^M data:" + line + ",", e);
				}
            }
		} catch (IOException e) {
			boolean result = send(this, "TIME OUT ɂؒf܂");
			if(result) {
				writeLog(" TIME OUT ɂؒf ", e);
			} else {
				writeLog(" Client ؒf ", e);
			}
		} finally {
			close(this);
		}
	}

	void sendAll(String name, String message) {
		StringBuffer sb = new StringBuffer();
		//sb.append(getTime());
		if(name != null) {
			sb.append(name);
			sb.append(": ");
		}
		sb.append(message);
		String mes = sb.toString();
		System.out.println(getTime() + sb);
        for (ConnectionHandler ch : clmgr) {
        	send(ch, mes);
		}
	}
	
	boolean send(ConnectionHandler ch, String mes) {
		boolean result = false;
    	try {
    		ch.out.write(mes, 0, mes.length());
    		ch.out.newLine();
    		ch.out.flush();
    		result = true;
    	} catch (SocketException e) {
			ch.close(ch);
    	} catch (IOException e) {
    		writeLog(" send\bhŗO ", e);
			ch.close(ch);
    	}
    	return result;
	}

    // TODO: ް²
	void setName(String name) {
		this.name = name;
    	try {
			out.newLine();
			this.out.write(" > 悤A" + name + "I");
			out.newLine();
	        out.flush();
	        sendAll(null, name + "񂪃OC܂");
	        clmgr.add(this);
    	} catch (IOException e) {
			writeLog(" setName\bhŗO ", e);
			close(this);
    	}
	}

	// TODO: ްޮ
	void close(ConnectionHandler ch) {
		if( clmgr.contains(ch) ) {
			clmgr.remove(ch);
			sendAll(null, ch.name + "񂪃OAEg܂");
		}
		try { 
			ch.socket.close(); 
		} catch (IOException e) {
			writeLog(" close\bhŗO ", e);
		}
	}
	
	String getTime() {
		return new SimpleDateFormat("hh:mm:ss ").format(new Date());
	}
	
	// TODO: ر
	void writeLog(String log, Exception e) {
		System.out.println("### ERROR LOG ###");
		StringBuffer sb = new StringBuffer();
		sb.append(getTime());
		sb.append(log);
		sb.append(" user name:" + this.name);
		System.out.println(sb);
		e.printStackTrace();
	}
}
